package cn.com.infosec.asn1.ocsp;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERGeneralizedTime;
import cn.com.infosec.asn1.DERIA5String;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.DERTaggedObject;
import java.util.Enumeration;

public class CrlID extends ASN1Encodable {
   DERIA5String crlUrl;
   DERInteger crlNum;
   DERGeneralizedTime crlTime;

   public CrlID(ASN1Sequence seq) {
      Enumeration seq1 = seq.getObjects();

      while(seq1.hasMoreElements()) {
         ASN1TaggedObject var2;
         int var3;
         if ((var3 = (var2 = (ASN1TaggedObject)seq1.nextElement()).getTagNo()) != 0) {
            if (var3 != 1) {
               if (var3 != 2) {
                  throw new IllegalArgumentException("unknown tag number: " + var2.getTagNo());
               }

               this.crlTime = DERGeneralizedTime.getInstance(var2, true);
            } else {
               this.crlNum = DERInteger.getInstance(var2, true);
            }
         } else {
            this.crlUrl = DERIA5String.getInstance(var2, true);
         }
      }

   }

   public DERIA5String getCrlUrl() {
      return this.crlUrl;
   }

   public DERInteger getCrlNum() {
      return this.crlNum;
   }

   public DERGeneralizedTime getCrlTime() {
      return this.crlTime;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      var1 = new ASN1EncodableVector.<init>();
      DERIA5String var2;
      DERTaggedObject var3;
      if ((var2 = this.crlUrl) != null) {
         var3 = new DERTaggedObject.<init>(true, 0, var2);
         var1.add(var3);
      }

      DERInteger var5;
      if ((var5 = this.crlNum) != null) {
         var3 = new DERTaggedObject.<init>(true, 1, var5);
         var1.add(var3);
      }

      DERGeneralizedTime var4;
      if ((var4 = this.crlTime) != null) {
         DERTaggedObject var6;
         var6 = new DERTaggedObject.<init>(true, 2, var4);
         var1.add(var6);
      }

      return new DERSequence(var1);
   }
}
